// Berker E12 Frontplatte
// -- bbrunner_prusa@epr.ch 2023-01-07
include <BOSL/constants.scad>
use <BOSL/shapes.scad>
use <BOSL/masks.scad>
use <BOSL/transforms.scad>

eps=0.05;
eps2=2*eps;

$fn=50;

// Spool didth
W=60; // 62 - 60
// Spool depth
D=50;
// Thickness of base plate
TH=3;
// Thicknes of snap tube 
TTH=3;

// Tube diameter including slack
TUBE=6 + 0.3;
SLACK=0.2;

// Sprocket length
SPROCKET=5;
// Sprocked position
SPROCKETX=20;

difference(){
    // base plate
    cuboid([W,D,TH]); // , fillet=TH/2, edges=EDGES_FRONT);

    holer=W/2;
    translate([0, -W/2-2, -TH/2-eps]) {
        scale([holer, holer, 1])
            cylinder(h=TH+eps2, 1, 1);
        up(TH) fillet_hole_mask(r=holer, fillet=TH/2);
        rotate([0,180,0]) fillet_hole_mask(r=holer, fillet=TH/2);
    }
}
    
translate([0, D/2+TTH*0, -TUBE/2-TTH/2]) rotate([0, 90, 0]) snaptube();

translate([-W/2-SPROCKET/2+TH/2,-D/2 + SPROCKETX, 0]) rotate([0, 90, 0]) cyl(d=TH, l=SPROCKET, fillet1=TH/2);

translate([+W/2+SPROCKET/2-TH/2,-D/2 + SPROCKETX, 0]) rotate([0, 90, 0]) cyl(d=TH, l=SPROCKET, fillet2=TH/2);

// snaptube();

module snaptube()
{
    translate([0,0,-W/2])
    difference(){
        cylinder(h=W, r=TUBE/2 + TTH);
        translate([0,0,-eps]) {
            cylinder(h=W+2*eps, r=TUBE/2); 
            translate([0, -TUBE/2+3*SLACK /2, 0]) cube([TUBE+2*TTH, TUBE-4*SLACK, W+2*eps]);
        }
    }

}
